
enum {
	Sunwanted,		// needs to be shutdown
	Sactive,		// should/is listening
};

typedef struct _Ann Ann;
struct _Ann {
	Ann *next;
	char *path;		// path to command
	char *proto;		// protocol name
	int port;		// port to listen on
	int sock;		// socket
	HANDLE srv;		// port server handle
	HANDLE stop;		// flagged to stop listening
	int state;		// is (or should be) listening
};

extern int listendir(char *, char *);

extern void debug(char *, ...);
extern void syslog(char *, ...);
extern char *enquote(char *, int);

extern int dolisten(Ann *);
unsigned long WINAPI doaccept(void *);
extern void ignore(Ann *);

extern int svs_inst(char *, char *);
extern int svs_uninst(char *);
extern int svs_start(char *);
extern int svs_stop(char *);
extern int svs_serv(char *);

extern void becomenone(void);
extern void usage(char *);
extern void stamp(char *, int, char *[]);

extern void initenv(void);

extern int Debug;
extern int Amservice;
extern char *argv0;
extern Ann *Announce;
extern HANDLE Finished;
extern int Trusted;
extern char *Logfile;
extern char *Ctldir;
extern char *Proto;
