#include <u.h>
#include <libc.h>

static int type;

void
catch(void *p, char *note)
{
	print("caught %s\n", note);

	switch(type){
	case 1:
		noted(NCONT);
		break;
	case 2:
		noted(NDFLT);
		break;
	default:
		break;
	}
}

void
main(int argc, char *argv[])
{
	if(argc != 2){
		fprint(2, "usage: %s noted\n", argv[0]);
		fprint(2, "  noted is the value to call noted() with\n");
		fprint(2, "   %d NCONT\n", NCONT);
		fprint(2, "   %d NDFLT\n", NDFLT);
		fprint(2, "   3  <panic>\n", NDFLT);
		exits("usage");
	}

	type = atoi(argv[1]);

	if(notify(catch) < 0) {
		fprint(2, "notify: %r\n");
		exits("notify");
	}
	while(1)
		sleep(10);
	exits(0);
}
