#include <u.h>
#include <libc.h>

void
main(int argc, char *argv[])
{
	if(argc != 3){
		fprint(2, "usage: %s pid note\n", argv[0]);
		exits("usage");
	}

	if(postnote(PNPROC, atoi(argv[1]), argv[2]) < 0) {
		fprint(2, "postnote: %r\n");
		exits("postnote");
	}
	exits(0);
}
