#include <u.h>
#include <libc.h>
#include <mswin.h>

static void
fix(wchar_t *path)
{
	HANDLE h;
	int full, tail;
	WIN32_FIND_DATA fd;

	if((h = FindFirstFileW(path, &fd)) == INVALID_HANDLE_VALUE)
		return;
	FindClose(h);

	full = _winlen(path);
	tail = _winlen(fd.cFileName);

	if(memcmp(path +(full-tail), fd.cFileName, tail * sizeof(wchar_t)) != 0)
		memcpy(path +(full-tail), fd.cFileName, tail * sizeof(wchar_t));
}

wchar_t *
_fixpath(wchar_t *path)
{
	int wildcard;
	wchar_t t, *pos, *e;
return path;					/* FIXME: This is broken, I think it can write off the end of its string, particularly paths like ../../fred/jim.c */

	if(_wincmp(path, L".") == 0)
		return path;

	pos = path;
	if(isalpharune(pos[0]) && pos[1] == L':'){
		if(isalpharune(pos[0]) && pos[1] == L':')
			pos[0] = tolowerrune(pos[0]);
		pos += 2;
	}
	if(*pos == '/' || *pos == '\\')
		pos++;

	do{
		wildcard = 0;
		for(e = pos; *e; e++){
			if(*e == L'*' || *e == L'?' || *e == L'>' || *e == L'<')
				wildcard = 1;
			if(*e == L'/' || *e == L'\\')
				break;
		}

		if(! wildcard){				/* do not expand wildcard path elements */
			t = *e;
			*e = 0;
			fix(path);
			*e = t;
		}

		pos = e +1;
	}while(*e);

	return path;
}

