#include <u.h>
#include <libc.h>
#include <mswin.h>
#include "error.h"
#include "9win.h"

int
chdir(char *path)
{
	int rc;
	Proc *p;
	wchar_t *tmp;

	tmp = _winpath(path);
	_fixpath(tmp);
	rc = SetCurrentDirectory(tmp);
	free(tmp);

	if(rc == 0){
		werrstr("%s %s", path, _winerr());
		return -1;
	}
	
	p = _getproc();
	free(p->cwd);
	p->cwd = _getcwd();

	return 0;
}
