#include <u.h>
#include <libc.h>
#include <mswin.h>
#include "9win.h"

char *
_getcwd(void)
{
	char *tmp2;
	int sz, got;
	wchar_t *tmp1;

	if((sz = GetCurrentDirectory(0, nil)) == 0){
		werrstr("%s", _winerr());
		return nil;
	}
	if((tmp1 = mallocz(sz * sizeof(wchar_t) +1, 0)) == nil)
		return nil;
	if((got = GetCurrentDirectory(sz, tmp1)) == 0){
		free(tmp1);
		werrstr("%s", _winerr());
		return nil;
	}
	_fixpath(tmp1);
	tmp2 = _ninepath(tmp1);
	free(tmp1);
	return tmp2;
}

char *
getwd(char *s, int n)
{
	char *str;
	
	str = _getcwd();
	snprint(s, n, "%s", str);
	free(str);
	return s;
}

