#include <u.h>
#include <libc.h>
#include <mswin.h>
#include "9win.h"

void *
malloc(ulong n)
{
	void *p;

	p = HeapAlloc(GetProcessHeap(), 0, n);
	if(p == nil){
		werrstr("malloc(%lud) failed: %s", n, _winerr());
abort();
		return nil;
	}
	return p;
}

void
setmalloctag(void *v, ulong pc)
{
	USED(v);
	USED(pc);
}

ulong
getmalloctag(void *v)
{
	USED(v);
	return ~0;
}

