#include <u.h>
#include <libc.h>
#include <mswin.h>
#include "9win.h"

void *
realloc(void *old, ulong n)
{
	void *new;

	if(old == nil)
		new = HeapAlloc(GetProcessHeap(), 0, n);
	else{
		assert(HeapValidate(GetProcessHeap(), 0, old));
		new = HeapReAlloc(GetProcessHeap(), 0, old, n);
	}
	if(new == nil){
		werrstr("realloc(%p, %lud) failed: %s", old, n, _winerr());
		return nil;
	}
	return new;
}

void
setrealloctag(void *v, ulong pc)
{
	USED(v);
	USED(pc);
}

ulong
getrealloctag(void *v)
{
	USED(v);
	return ~0;
}
