#include <u.h>
#include <libc.h>
#include <mswin.h>
#include "9win.h"

static char *name;

char *
sysname(void)
{
	DWORD sz;
	wchar_t tmp[MAX_COMPUTERNAME_LENGTH+1];

	if(name)
		return name;

	/*
	 * dos(1) pushes plan9's name into our environment which
	 * may be nicer than our real hostname
	 */
	if((name = getenv("sysname")) != nil)
		return name;

	sz = nelem(tmp);
	if(GetComputerName(tmp, &sz) == 0)
		name = strdup("none");
	else
		name = _ninestr(tmp);
	return name;
}
