#include <u.h>
#include <libc.h>
#include "error.h"
#include <mswin.h>
#include "9win.h"

vlong
_ft2epoch(FILETIME *ft)		/* returns milliseconds since 1/1/70 */
{
	vlong vl;

	vl = ft->dwHighDateTime;
	vl <<= 32;
	vl |= ft->dwLowDateTime;
	vl /= 10000LL;
	vl -= 11644473600000LL;
	return vl;	
}

long
time(long *t)
{
	vlong vl;
	FILETIME ft;

	GetSystemTimeAsFileTime(&ft);
	vl = _ft2epoch(&ft);
	vl /= 1000;			/* ms to sec */
	if(t)
		*t = vl;
	return vl;
}

