#include <u.h>
#include <libc.h>
#include <mswin.h>

#include <winsock2.h>
#include <ws2tcpip.h>

int 
_skt_bind(int skt, void *addr, int len)
{
	static int WINAPI (*f)(int skt, void *addr, int len);

	if(! f)
		f = _latebind(WINSOCK2_DLL, "bind");
	if(f(skt, addr, len) != 0){
		werrstr("%s", _skt_errstr());
		return -1;
	}
	return 0;
}
