#include <u.h>
#include <libc.h>
#include <mswin.h>

#include <winsock2.h>
#include <ws2tcpip.h>

int 
_skt_getsockopt(int skt, int level, int opt, char *buf, int *len)
{
	static int WINAPI (*f)(SOCKET skt, int level, int opt, char *buf, int *len);

	if(! f)
		f = _latebind(WINSOCK2_DLL, "getsockopt");

	if(f(skt, level, opt, buf, len)){
		werrstr("%s", _skt_errstr());
		return -1;
	}
	return 0;
}

