#include <u.h>
#include <libc.h>
#include <mswin.h>

#include <winsock2.h>
#include <ws2tcpip.h>

int 
_skt_socket(int family, int type, int proto)
{
	SOCKET skt;
	static int WINAPI (*f)(int family, int type, int proto);

	if(! f)
		f = _latebind(WINSOCK2_DLL, "socket");
	if((skt = f(family, type, proto)) == -1){
		werrstr("%s", _skt_errstr());
		return -1;
	}
	return skt;
}

