#include <u.h>
#include <libc.h>
#include <mswin.h>

#include <winsock2.h>
#include <ws2tcpip.h>

int 
_skt_write(int skt, void *buf, int len)
{
	int n;
	static int WINAPI (*f)(int skt, char *buf, int len, int flags);

	if(f == NULL)
		f = _latebind(WINSOCK2_DLL, "send");

	if((n = f(skt,  buf, len, 0)) < 0){
		werrstr("%s", _skt_errstr());
		return -1;
	}
	return n;
}

