#include <u.h>
#include <libc.h>
#include <thread.h>
#include "threadimpl.h"


static __cdecl void
launch(void (*f)(void *arg), void *arg)
{
	(*f)(arg);
	threadexits(nil);
}

void
_threadinitstack(Thread *t, void (*f)(void*), void *arg)
{
	ulong *tos;

	tos = (ulong*)&t->stk[t->stksize&~7];
	*--tos = (ulong)arg;
	*--tos = (ulong)f;
	t->sched[JMPBUFPC] = (ulong)launch+JMPBUFDPC;
	t->sched[JMPBUFSP] = (ulong)tos -4;
}

