#define memchr		x_memchr
#define memcmp		x_memcmp
#define memcpy		x_memcpy
#define memmove		x_memmove
#define memset		x_memset
#define strcat		x_strcat
#define strchr		x_strchr
#define strcmp		x_strcmp
#define strcpy		x_strcpy
#define strcspn		x_strcspn
#define strlen		x_strlen
#define strncat		x_strncat
#define strncmp		x_strncmp
#define strncpy		x_strncpy
#define strpbrk		x_strpbrk
#define strrchr		x_strrchr
#define strspn		x_strspn
#define strstr		x_strstr
#define strtok		x_strtok
#define memccpy		x_memccpy
#define strdup		x_strdup
#define accept		x_accept
#define bind		x_bind
#define listen		x_listen
#define atof		x_atof
#define atoi		x_atoi
#define atol		x_atol
#define strtod		x_strtod
#define strtol		x_strtol
#define strtoul		x_strtoul
#define srand		x_srand
#define calloc		x_calloc
#define malloc		x_malloc
#define realloc		x_realloc
#define getenv		x_getenv
#define qsort		x_qsort
#define putenv		x_putenv
#define strtoll		x_strtoll
#define strtoull	x_strtoull
#define atoll		x_atoll
#define Arc			x_Arc
#define div			x_div
#define recv		x_recv
#define send		x_send

#define UNICODE
#define _WIN32_WINNT 0x0601
#include <windows.h>

#undef memchr
#undef memcmp
#undef memcpy
#undef memmove
#undef memset
#undef strcat
#undef strchr
#undef strcmp
#undef strcpy
#undef strcspn
#undef strlen
#undef strncat
#undef strncmp
#undef strncpy
#undef strpbrk
#undef strrchr
#undef strspn
#undef strstr
#undef strtok
#undef memccpy
#undef strdup
#undef accept
#undef bind
#undef listen
#undef atof
#undef atoi
#undef atol
#undef strtod
#undef strtol
#undef strtoul
#undef srand
#undef calloc
#undef malloc
#undef realloc
#undef getenv
#undef qsort
#undef putenv
#undef strtoll
#undef strtoull
#undef atoll
#undef Arc
#undef div
#undef recv
#undef send

/* shorthand */
#define BadHand	INVALID_HANDLE_VALUE

char *_ninestr(wchar_t *str);
char *_nineuser(wchar_t *dom, wchar_t *user);
char *_ninepath(wchar_t *path);
char *_nineargv(wchar_t *cli, int *ac, char ***av);

wchar_t *_winstr(char *str);
wchar_t *_winpath(char *path);
wchar_t *_winpath2(char *base, wchar_t *name);

wchar_t *_winenv(char *str);

int _winlen(wchar_t *s);
int _wincmp(wchar_t *s, wchar_t *t);

char **_getenvp(void);
wchar_t *_winenviron(void);

char *_winerr(void);
char *_wsaerr(void);
char *_ntdllerr(uint err);
char *_wneterr(uint err);

char *_sid2name(PSID sid, int agression);

vlong _ft2elap(FILETIME *ft);
vlong _ft2epoch(FILETIME *ft);

wchar_t *_fixpath(wchar_t *);

void *_latebind(char *lib, char *name);
int _takepriv(wchar_t *name);
int _samefile(wchar_t *src, wchar_t *dst);

char *_linktarg(char *path);

int _skt_bind(int skt, void *addr, int len);
int _skt_close(int skt);
int _skt_connect(int skt, struct sockaddr *name, int namelen);
char *_skt_errstr(void);
int _skt_startup(void);
int _skt_accept(int skt, char *, int *len);
int _skt_listen(int skt, int quelen);
int _skt_read(int skt, void *buf, int len);
int _skt_setsockopt(int skt, int level, int opt, char *buf, int len);
int _skt_getsockopt(int skt, int level, int opt, char *buf, int *len);
int _skt_socket(int skt, int type, int proto);
int _skt_write(int skt, void *buf, int len);
int _skt_shutdown(int skt, int which);

#pragma	   varargck    type  "w"   wchar_t
#pragma	   varargck    type  "W"   wchar_t
int _widefmtinstall(void);

/* push windows symlinks through the plan9 API */
#define DMLINK	0x02000000
#define QTLINK	0x02

#define WINSOCK2_DLL	"ws2_32.dll"
