#define nelem(x)	(sizeof((x))/sizeof((x)[0]))
#define nil		((void *)0)

enum {
	OREAD = 0,
	OWRITE = 1,
	ORDWR = 2
};

typedef struct {
	HANDLE inp;
	HANDLE out;
	HANDLE note;
	int refs;
	char *mntpt;
	int mntlen;
} NineP;

typedef struct {
	NineP *np;
	char *name;
	int mode;
	int id;

	char *buf;
	int len;
	int off;
} Fid;

extern NineP *attach9(HANDLE, HANDLE, char *, char *);
extern Fid *open9(NineP *np, char *file, int mode);
extern int read9(Fid *fid, void *buf, int bytes);
extern int line9(Fid *fid, char *buf, int nbytes);
extern int write9(Fid *fid, void *buf, int bytes);
extern int close9(Fid *fid);
extern int detach9(NineP *np);

extern int getmap(NineP *, char *);
extern int getns(NineP *);
extern int checkprompt(NineP *, char);
extern void unmapall(void);
extern void mapall(void);

extern void sysfatal(char *, ...);
extern void syswarn(char *, ...);
extern void syslog(char *, ...);
extern int errstr(unsigned long, char *, int);

enum {
	Npath = 1024,
};
