#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <stdarg.h>
#include <windows.h>
#include "dosd.h"

int
getstr(HANDLE inp, char *buf, int n)
{
	char c, *p;
	unsigned long got;

	memset(buf, 0, n);
	p = buf;
	while(n--){
		if(ReadFile(inp, &c, 1, &got, NULL) == 0)
			break;
		if(got != 1 || c == '\n')
			break;
		*p++ = c;
	}
	*p = 0;

	if(*buf == 0)	/* empty string */
		return 0;
	return 1;
}

void
putstr(HANDLE out, char *fmt, ...)
{
	va_list args;
	char s[1024];
	unsigned long n, m;

	va_start(args, fmt);
	n = vsnprintf(s, sizeof(s), fmt, args);
	va_end(args);


	if(WriteFile(GetStdHandle(STD_OUTPUT_HANDLE), s, n, &m, NULL) == 0)
		sysfatal("putstr: WriteFile failed");
	if(n != m)
		sysfatal("putstr: short write (%d < %d)", n, m);
}

