#include <u.h>
#include <libc.h>
#include <fcall.h>
#include <ctype.h>
#include <mswin.h>
#include "9win.h"

int
_dostat(char *path, Dir *d)
{
	int attr;
	HANDLE h;
	wchar_t *tmp;
	WIN32_FIND_DATA fd;

	tmp = _winpath(path);
	if((h = FindFirstFile(tmp, &fd)) != BadHand){
		_find2dir(path, tmp, &fd, d);
		FindClose(h);
	}
	else{
		if((attr = GetFileAttributes(tmp)) == -1){
			werrstr("'%s' %s", path, _winerr());
			free(tmp);
			return -1;
		}
		_attr2dir(path, tmp, attr, d);
	}
	free(tmp);
	return 0;
}
