#include <u.h>
#include <libc.h>
#include <mswin.h>
#include "9win.h"

int
fd2path(int fd, char *s, int n)
{
	File *f;
	Fgrp *fg;

	fg = _getproc()->fgrp;
	qlock(fg);
	if((f = _lookfile(fg, fd)) == nil){
		qunlock(fg);
		return -1;
	}
	qlock(f);
	qunlock(fg);

	*s = 0;
	strecpy(s, s + n, f->path);
	if(strlen(f->path) >= n)
		werrstr("buffer too small");
	qunlock(f);
	return 0;
}

