#include <u.h>
#include <libc.h>
#include <mswin.h>
#include "9win.h"


char *
getuser(void)
{
	char *s;
	HANDLE h;
	DWORD nbuf;
	TOKEN_USER *t;
	uchar buf[8192];
	static char name[8192];

	if(*name)
		return name;

	if(OpenThreadToken(GetCurrentThread(), TOKEN_QUERY, 0, &h) == 0){
		strcpy(name, "none");
		return name;
	}

	nbuf = sizeof(buf);
	if(GetTokenInformation(h, TokenUser, buf, nbuf, &nbuf) == 0){
		CloseHandle(h);
		strcpy(name, "none");
		return name;
	}
	CloseHandle(h);

	t = (TOKEN_USER *)buf;
	s = _sid2name(t->User.Sid, 100);
	strcpy(name, s);
	return name;
}
