#include <u.h>
#include <libc.h>
#include <mswin.h>
#include "9win.h"

int sleep(long ms)
{
	int err;
	Proc *p;

	p = _getproc();
	ResetEvent(p->rgrp->wait);
	err = WaitForSingleObjectEx(p->rgrp->wait, ms, 1);
	switch(err){
	case WAIT_TIMEOUT:
		break;
	case WAIT_OBJECT_0:		/* caught note, werrstr set by postnote */
		return -1;
	default:
		werrstr(_winerr());
		return -1;
	}
	return 0;
}
