#include <u.h>
#include <libc.h>
#include <fcall.h>
#include <mswin.h>
#include "9win.h"

int
stat(char *path, uchar *edir, int nedir)
{
	Dir d;
	int rc;

	if(_dostat(path, &d) == -1)
		return -1;
	rc = convD2M(&d, edir, nedir);
	free(d.muid);
	free(d.name);
	free(d.uid);
	free(d.gid);
	return rc;
}

