#include <u.h>
#include <libc.h>
#include "error.h"
#include <mswin.h>
#include "9win.h"

#include <winnetwk.h>

char *
_wneterr(uint err)
{
	DWORD exterr;
	wchar_t sys[256], msg[256];
	static char buf[ERRMAX];

	if(err != ERROR_EXTENDED_ERROR)
		return _winerr();

	if(WNetGetLastError(&exterr, msg, sizeof(msg), sys, sizeof(sys)) != NO_ERROR)
		return "";

	snprint(buf, sizeof(buf), "%S %S", sys, msg);

	_cleanerr(buf);
	return buf;
}
