#include <u.h>
#include <libc.h>
#include <fcall.h>
#include <mswin.h>
#include "9win.h"

int
wstat(char *path, uchar *edir, int nedir)
{
	Dir d1, *d;
	int rc, len;

	if((len = convM2D(edir, nedir, &d1, nil)) == 0)
		return -1;
	d = malloc(len+sizeof(Dir));
	if(convM2D(edir, nedir, d, (char *)&d[1]) == 0){
		free(d);
		return -1;
	}
	rc = _dowstat(path, d);
	free(d);
	return rc;
}


