#include <u.h>
#include <libc.h>
#include <mswin.h>

/* return a function pointer into a dll bound at runtime */
void *
_latebind(char *lib, char *name)
{
	void *v;
	HANDLE h;
	wchar_t *tmp;

	tmp = _winstr(lib);
	h = LoadLibrary(tmp);
	free(tmp);

	if(h == nil)
		sysfatal("%s cannot find library, %s", lib, _winerr());
	if((v = GetProcAddress(h, name)) == nil)
		sysfatal("%s: %s symbol not found in library, %s", lib, name, _winerr());
//	CloseHandle(h);
	return v;
}

