#include <u.h>
#include <libc.h>
#include <mswin.h>

#include <winsock2.h>
#include <ws2tcpip.h>

int 
_skt_accept(int skt, char *addr, int *addrlen)
{
	int fd;
	static int WINAPI (*f)(int skt, char *addr, int *addrlen);

	if(! f)
		f = _latebind(WINSOCK2_DLL, "accept");
	if((fd = f(skt, addr, addrlen)) == -1){
		werrstr("%s", _skt_errstr());
		return -1;
	}
	return fd;
}

