#include <u.h>
#include <libc.h>
#include <mswin.h>

#include <winsock2.h>
#include <ws2tcpip.h>

int 
_skt_read(int skt, void *buf, int len)
{
	WSABUF wb;
	DWORD got, flags;
	static int WINAPI (*f)(int skt, WSABUF *sb, int nbuf, DWORD *got,
		DWORD *flags, WSAOVERLAPPED *olap, LPWSAOVERLAPPED_COMPLETION_ROUTINE func);

	if(! f)
		f = _latebind(WINSOCK2_DLL, "WSARecv");

	flags = 0;
	wb.buf = buf;
	wb.len = len;
	if(f(skt,  &wb, 1, &got, &flags, nil, nil) != 0){
		werrstr("%s", _skt_errstr());
		return -1;
	}
	return got;
}

